package com.fun.wave.pranksounds.main;

import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.fun.wave.pranksounds.activity.ListActivity;
import com.fun.wave.pranksounds.listener.SoundsWrapper;
import com.fun.wave.pranksounds.utils.Common;
import com.fun.wave.pranksounds.databinding.MainAdapterBinding;

import java.util.List;


public class MainAdapter extends RecyclerView.Adapter<MainAdapter.ViewHolder> {

    private final List<SoundsWrapper> mValues;

    private Context mCon;


    public MainAdapter(Context context, List<SoundsWrapper> items) {
        mValues = items;
        this.mCon = context;
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {

        return new ViewHolder(MainAdapterBinding.inflate(LayoutInflater.from(parent.getContext()), parent, false));

    }

    @Override
    public void onBindViewHolder(final ViewHolder holder, int position) {
        int absoluteAdapterPosition = holder.getAbsoluteAdapterPosition();
        int i = absoluteAdapterPosition % 6;
        holder.vb.relative.setBackground(ContextCompat.getDrawable(mCon, Common.bgs[i]));
        SoundsWrapper soundsWrapper = mValues.get(absoluteAdapterPosition);
        String covert = soundsWrapper.getCovert();
        Glide.with(mCon).load(covert).into(holder.vb.image);
        holder.vb.name.setText(soundsWrapper.getName());
        holder.vb.relative.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(mCon, ListActivity.class);
                intent.putExtra(Common.KEY_LIST_DATA, soundsWrapper);
                intent.putExtra(Common.KEY_LIST_COLOR_POS, i);
                mCon.startActivity(intent);
            }
        });
        if(absoluteAdapterPosition == mValues.size()-1||absoluteAdapterPosition == mValues.size()-2){
            holder.vb.view.setVisibility(View.VISIBLE);
        }else {
            holder.vb.view.setVisibility(View.GONE);
        }

    }

    @Override
    public int getItemCount() {
        return mValues.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder {

        private MainAdapterBinding vb;

        public ViewHolder(MainAdapterBinding binding) {
            super(binding.getRoot());
            vb = binding;

        }
    }
}